Open CASCADE Technology: XSControl_WorkSession Class Reference

Open CASCADE Technology 6.9.1

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions
XSControl_WorkSession Class Reference

This WorkSession completes the basic one, by adding : More...

`#include <XSControl_WorkSession.hxx>`

Inheritance diagram for XSControl_WorkSession:
[legend]

## Public Member Functions
| XSControl_WorkSession ()
virtual void | ClearData (const Standard_Integer mode)
| In addition to basic ClearData, clears Transfer and Management for interactive use, for mode = 0,1,2 and over 4 Plus : mode = 5 to clear Transfers (both ways) only mode = 6 to clear enforced results mode = 7 to clear transfers, results. More...
Standard_Boolean | SelectNorm (const Standard_CString normname, const Standard_CString profile="")
| Selects a Norm defined by its name. A Norm is described and handled by a Controller Returns True if done, False if <normname> is unknown. More...
Standard_Boolean | SelectProfile (const Standard_CString profile)
| Sets a Profile as current for the current Norm Returns True if done, False if <profile> is unknown for this norm. More...
void | SetController (const Handle< XSControl_Controller > &ctl)
| Selects a Norm defined by its Controller itself. More...
virtual void | AdaptNorm ()
| This method is called once a new norm has been successfully selected. It can be redefined, default does nothing. More...
Standard_CString | SelectedNorm (const Standard_Boolean rsc=Standard_False) const
| Returns the name of the last Selected Norm. If none is defined, returns an empty string By default, returns the complete name of the norm If <rsc> is True, returns the short name used for resource. More...
Handle< XSControl_Controller > | NormAdaptor () const
| Returns the norm controller itself. More...
Handle< Dico_DictionaryOfTransient > | Context () const
| Returns the current Context List, Null if not defined The Context is given to the TransientProcess for TransferRead. More...
void | SetAllContext (const Handle< Dico_DictionaryOfTransient > &context)
| Sets the current Context List, as a whole Sets it to the TransferReader. More...
void | ClearContext ()
| Clears the whole current Context (nullifies it) More...
Standard_Boolean | PrintTransferStatus (const Standard_Integer num, const Standard_Boolean wri, const Handle< Message_Messenger > &S) const
| Prints the transfer status of a transferred item, as beeing the Mapped n0 <num>, from MapWriter if <wri> is True, or from MapReader if <wri> is False Returns True when done, False else (i.e. num out of range) More...
void | InitTransferReader (const Standard_Integer mode)
| Sets a Transfer Reader, by internal ways, according mode : 0 recreates it clear, 1 clears it (does not recreate) 2 aligns Roots of TransientProcess from final Results 3 aligns final Results from Roots of TransientProcess 4 begins a new transfer (by BeginTransfer) 5 recreates TransferReader then begins a new transfer. More...
void | SetTransferReader (const Handle< XSControl_TransferReader > &TR)
| Sets a Transfer Reader, which manages transfers on reading. More...
Handle< XSControl_TransferReader > | TransferReader () const
| Returns the Transfer Reader, Null if not set. More...
Handle< Transfer_TransientProcess > | MapReader () const
| Returns the TransientProcess(internal data for TransferReader) More...
Standard_Boolean | SetMapReader (const Handle< Transfer_TransientProcess > &TP)
| Changes the Map Reader, i.e. considers that the new one defines the relevant read results (forgets the former ones) Returns True when done, False in case of bad definition, i.e. if Model from TP differs from that of Session. More...
Handle< Standard_Transient > | Result (const Handle< Standard_Transient > &ent, const Standard_Integer mode) const
| Returns the result attached to a starting entity If <mode> = 0, returns Final Result If <mode> = 1, considers Last Result If <mode> = 2, considers Final, else if absent, Last returns it as Transient, if result is not transient returns the Binder <mode> = 10,11,12 idem but returns the Binder itself (if it is not, e.g. Shape, returns the Binder) <mode> = 20, returns the ResultFromModel. More...
Standard_Integer | TransferReadOne (const Handle< Standard_Transient > &ents)
| Commands the transfer of, either one entity, or a list I.E. calls the TransferReader after having analysed <ents> It is cumulated from the last BeginTransfer <ents> is processed by GiveList, hence : More...
Standard_Integer | TransferReadRoots ()
| Commands the transfer of all the root entities of the model i.e. calls TransferRoot from the TransferReader with the Graph No cumulation with former calls to TransferReadOne. More...
Handle< Interface_InterfaceModel > | NewModel ()
| produces and returns a new Model well conditionned It is produced by the Norm Controller It can be Null (if this function is not implemented) More...
Handle< XSControl_TransferWriter > | TransferWriter () const
| Returns the Transfer Reader, Null if not set. More...
Handle< Transfer_FinderProcess > | MapWriter () const
| Returns the FinderProcess (internal data for TransferWriter) More...
Standard_Boolean | SetMapWriter (const Handle< Transfer_FinderProcess > &FP)
| Changes the Map Reader, i.e. considers that the new one defines the relevant read results (forgets the former ones) Returns True when done, False if <FP> is Null. More...
void | SetModeWriteShape (const Standard_Integer mode)
| Sets a mode to transfer Shapes from CasCade to entities of the current norm, which interprets it (see various Controllers) This call form could be later replaced by a more general one. More...
Standard_Integer | ModeWriteShape () const
| Records the current Mode to Write Shapes. More...
IFSelect_ReturnStatus | TransferWriteShape (const TopoDS_Shape &shape, const Standard_Boolean compgraph=Standard_True)
| Transfers a Shape from CasCade to a model of current norm, according to the last call to SetModeWriteShape Returns status :Done if OK, Fail if error during transfer, Error if transfer badly initialised. More...
Interface_CheckIterator | TransferWriteCheckList () const
| Returns the check-list of last transfer (write) It is recorded in the FinderProcess, but it must be bound with resulting entities (in the resulting file model) rather than with original objects (in fact, their mappers) More...
Handle< XSControl_Vars > | Vars () const
void | SetVars (const Handle< XSControl_Vars > &newvars)
void | ClearBinders ()
| Clears binders. More...
void | Destroy ()
| ~XSControl_WorkSession ()
Public Member Functions inherited from IFSelect_WorkSession
| IFSelect_WorkSession ()
| Creates a Work Session It provides default, empty ShareOut and ModelCopier, which can be replaced (if required, should be done just after creation). More...
void | SetErrorHandle (const Standard_Boolean hand)
| Changes the Error Handler status (by default, it is not set) More...
Standard_Boolean | ErrorHandle () const
| Returns the Error Handler status. More...
const Handle< IFSelect_ShareOut > & | ShareOut () const
| Returns the ShareOut defined at creation time. More...
void | SetShareOut (const Handle< IFSelect_ShareOut > &shareout)
| Sets a new ShareOut. Fills Items which its content Warning : data from the former ShareOut are lost. More...
void | SetModeStat (const Standard_Boolean theMode)
| Set value of mode responsible for precence of selections after loading If mode set to true that different selections will be accessible after loading else selections will be not accessible after loading( for economy memory in applicatios) More...
Standard_Boolean | GetModeStat () const
| Return value of mode defining of filling selection during loading. More...
void | SetLibrary (const Handle< IFSelect_WorkLibrary > &lib)
| Sets a WorkLibrary, which will be used to Read and Write Files. More...
Handle< IFSelect_WorkLibrary > | WorkLibrary () const
| Returns the WorkLibrary. Null Handle if not yet set should be C++ : return const &. More...
void | SetProtocol (const Handle< Interface_Protocol > &protocol)
| Sets a Protocol, which will be used to determine Graphs, to Read and to Write Files. More...
Handle< Interface_Protocol > | Protocol () const
| Returns the Protocol. Null Handle if not yet set should be C++ : return const &. More...
void | SetSignType (const Handle< IFSelect_Signature > &signtype)
| Sets a specific Signature to be the SignType, i.e. the Signature which will determine TypeName from the Model (basic function). It is recorded in the GTool This Signature is also set as "xst-sign-type" (reserved name) More...
Handle< IFSelect_Signature > | SignType () const
| Returns the current SignType. More...
Standard_Boolean | HasModel () const
| Returns True is a Model has been set. More...
void | SetModel (const Handle< Interface_InterfaceModel > &model, const Standard_Boolean clearpointed=Standard_True)
| Sets a Model as input : this will be the Model from which the ShareOut will work if <clearpointed> is True (default) all SelectPointed items are cleared, else they must be managed by the caller Remark : SetModel clears the Graph, recomputes it if a Protocol is set and if the Model is not empty, of course. More...
Handle< Interface_InterfaceModel > | Model () const
| Returns the Model of the Work Session (Null Handle if none) should be C++ : return const &. More...
void | SetLoadedFile (const Standard_CString filename)
| Stores the filename used for read for setting the model It is cleared by SetModel and ClearData(1) More...
Standard_CString | LoadedFile () const
| Returns the filename used to load current model empty if unknown. More...
IFSelect_ReturnStatus | ReadFile (const Standard_CString filename)
| Reads a file with the WorkLibrary (sets Model and LoadedFile) Returns a integer status which can be : RetDone if OK, RetVoid if no Protocol not defined, RetError for file not found, RetFail if fail during read. More...
Standard_Integer | NbStartingEntities () const
| Returns the count of Entities stored in the Model, or 0. More...
Handle< Standard_Transient > | StartingEntity (const Standard_Integer num) const
| Returns an Entity stored in the Model of the WorkSession (Null Handle is no Model or num out of range) More...
Standard_Integer | StartingNumber (const Handle< Standard_Transient > &ent) const
| Returns the Number of an Entity in the Model (0 if no Model set or <ent> not in the Model) More...
Standard_Integer | NumberFromLabel (const Standard_CString val, const Standard_Integer afternum=0) const
| From a given label in Model, returns the corresponding number Starts from first entity by Default, may start after a given number : this number may be given negative, its absolute value is then considered. Hence a loop on NumberFromLabel may be programmed (stop test is : returned value positive or null) More...
Handle< TCollection_HAsciiString > | EntityLabel (const Handle< Standard_Transient > &ent) const
| Returns the label for <ent>, as the Model does If <ent> is not in the Model or if no Model is loaded, a Null Handle is returned. More...
Handle< TCollection_HAsciiString > | EntityName (const Handle< Standard_Transient > &ent) const
| Returns the Name of an Entity This Name is computed by the general service Name Returns a Null Handle if fails. More...
Standard_Integer | CategoryNumber (const Handle< Standard_Transient > &ent) const
| Returns the Category Number determined for an entity it is computed by the class Category An unknown entity (number 0) gives a value -1. More...
Standard_CString | CategoryName (const Handle< Standard_Transient > &ent) const
| Returns the Category Name determined for an entity it is computed by the class Category Remark : an unknown entity gives an empty string. More...
Standard_CString | ValidityName (const Handle< Standard_Transient > &ent) const
| Returns the Validity Name determined for an entity it is computed by the class SignValidity Remark : an unknown entity gives an empty string. More...
Standard_Boolean | ComputeGraph (const Standard_Boolean enforce=Standard_False)
| Computes the Graph used for Selections, Displays ... If a HGraph is already set, with same model as given by method Model, does nothing. Else, computes a new Graph. If <enforce> is given True, computes a new Graph anyway. Remark that a call to ClearGraph will cause ComputeGraph to really compute a new Graph Returns True if Graph is OK, False else (i.e. if no Protocol is set, or if Model is absent or empty). More...
Handle< Interface_HGraph > | HGraph ()
| Returns the Computed Graph as HGraph (Null Handle if not set) More...
const Interface_Graph & | Graph ()
| Returns the Computed Graph, for Read only. More...
Handle< TColStd_HSequenceOfTransient > | Shareds (const Handle< Standard_Transient > &ent)
| Returns the list of entities shared by <ent> (can be empty) Returns a null Handle if <ent> is unknown. More...
Handle< TColStd_HSequenceOfTransient > | Sharings (const Handle< Standard_Transient > &ent)
| Returns the list of entities sharing <ent> (can be empty) Returns a null Handle if <ent> is unknown. More...
Standard_Boolean | IsLoaded () const
| Returns True if a Model is defined and really loaded (not empty), a Protocol is set and a Graph has been computed. In this case, the WorkSession can start to work. More...
Standard_Boolean | ComputeCheck (const Standard_Boolean enforce=Standard_False)
| Computes the CheckList for the Model currently loaded It can then be used for displays, querries ... Returns True if OK, False else (i.e. no Protocol set, or Model absent). If <enforce> is False, works only if not already done or if a new Model has been loaded from last call. Remark : computation is enforced by every call to SetModel or RunTransformer. More...
Interface_CheckIterator | ModelCheckList (const Standard_Boolean complete=Standard_True)
| Returns the Check List for the Model currently loaded : <complete> = True : complete (syntactic & semantic messages), computed if not yet done <complete> = False : only syntactic (check file form) More...
Interface_CheckIterator | CheckOne (const Handle< Standard_Transient > &ent, const Standard_Boolean complete=Standard_True)
| Returns a Check for a single entity, under the form of a CheckIterator (this gives only one form for the user) if <ent> is Null or equates the current Model, it gives the Global Check, else the Check for the given entity <complete> as for ModelCheckList. More...
Interface_CheckIterator | LastRunCheckList () const
| Returns the Check List produced by the last execution of either : EvaluateFile(for Split), SendSplit, SendAll, SendSelected, RunTransformer-RunModifier Cleared by SetModel or ClearData(1) The field is protected, hence a specialized WorkSession may fill it. More...
Standard_Integer | MaxIdent () const
| Returns the Maximum Value for an Item Identifier. It can be greater to the count of known Items, because some can have been removed. More...
Handle< Standard_Transient > | Item (const Standard_Integer id) const
| Returns an Item, given its Ident. Returns a Null Handle if no Item corresponds to this Ident. More...
Standard_Integer | ItemIdent (const Handle< Standard_Transient > &item) const
| Returns the Ident attached to an Item in the WorkSession, or Zero if it is unknown. More...
Handle< Standard_Transient > | NamedItem (const Standard_CString name) const
| Returns the Item which corresponds to a Variable, given its Name (whatever the type of this Item). Returns a Null Handle if this Name is not recorded. More...
Handle< Standard_Transient > | NamedItem (const Handle< TCollection_HAsciiString > &name) const
| Same as above, but <name> is given through a Handle Especially Usefull with methods SelectionNames, etc... More...
Standard_Integer | NameIdent (const Standard_CString name) const
| Returns the Ident attached to a Name, 0 if name not recorded. More...
Standard_Boolean | HasName (const Handle< Standard_Transient > &item) const
| Returns True if an Item of the WorkSession has an attached Name. More...
Handle< TCollection_HAsciiString > | Name (const Handle< Standard_Transient > &item) const
| Returns the Name attached to an Item as a Variable of this WorkSession. If is Null or not recorded, returns an empty string. More...
Standard_Integer | AddItem (const Handle< Standard_Transient > &item, const Standard_Boolean active=Standard_True)
| Adds an Item and returns its attached Ident. Does nothing if is already recorded (and returns its attached Ident) <active> if True commands call to SetActive (see below) Remark : the determined Ident is used if is a Dispatch, to fill the ShareOut. More...
Standard_Integer | AddNamedItem (const Standard_CString name, const Handle< Standard_Transient > &item, const Standard_Boolean active=Standard_True)
| Adds an Item with an attached Name. If the Name is already known in the WorkSession, the older item losts it Returns Ident if Done, 0 else, i.e. if is null If <name> is empty, works as AddItem (i.e. with no name) If is already known but with no attached Name, this method tries to attached a Name to it <active> if True commands call to SetActive (see below) More...
Standard_Boolean | SetActive (const Handle< Standard_Transient > &item, const Standard_Boolean mode)
| Following the type of : More...
Standard_Boolean | RemoveNamedItem (const Standard_CString name)
| Removes an Item from the Session, given its Name Returns True if Done, False else (Name not recorded) (Applies only on Item which are Named) More...
Standard_Boolean | RemoveName (const Standard_CString name)
| Removes a Name without removing the Item Returns True if Done, False else (Name not recorded) More...
Standard_Boolean | RemoveItem (const Handle< Standard_Transient > &item)
| Removes an Item given its Ident. Returns False if <id> is attached to no Item in the WorkSession. For a Named Item, also removes its Name. More...
void | ClearItems ()
| Clears all the recorded Items : Selections, Dispatches, Modifiers, and Strings & IntParams, with their Idents & Names. Remark that if a Model has been loaded, it is not cleared. More...
Handle< TCollection_HAsciiString > | ItemLabel (const Standard_Integer id) const
| Returns a Label which illustrates the content of an Item, given its Ident. This Label is : More...
Handle< TColStd_HSequenceOfInteger > | ItemIdents (const Handle< Standard_Type > &type) const
| Fills a Sequence with the List of Idents attached to the Items of which Type complies with (IsKind) <type> (alphabetic order) Remark : <type> = TYPE(Standard_Transient) gives all the Idents which are suitable in the WorkSession. More...
Handle< TColStd_HSequenceOfHAsciiString > | ItemNames (const Handle< Standard_Type > &type) const
| Fills a Sequence with the list of the Names attached to Items of which Type complies with (IsKind) <type> (alphabetic order) Remark : <type> = TYPE(Standard_Transient) gives all the Names. More...
Handle< TColStd_HSequenceOfHAsciiString > | ItemNamesForLabel (const Standard_CString label) const
| Fills a Sequence with the NAMES of the control items, of which the label matches <label> (contain it) : see NextIdentForLabel Search mode is fixed to "contained" If <label> is empty, returns all Names. More...
Standard_Integer | NextIdentForLabel (const Standard_CString label, const Standard_Integer id, const Standard_Integer mode=0) const
| For query by Label with possible iterations Searches the Ident of which Item has a Label which matches a given one, the search starts from an initial Ident. Returns the first found Ident which follows <id>, or ZERO. More...
Handle< Standard_Transient > | NewParamFromStatic (const Standard_CString statname, const Standard_CString name="")
| Creates a parameter as being bound to a Static If the Static is Integer, this creates an IntParam bound to it by its name. Else this creates a String which is the value of the Static. Returns a null handle if <statname> is unknown as a Static. More...
Handle< IFSelect_IntParam > | IntParam (const Standard_Integer id) const
| Returns an IntParam, given its Ident in the Session Null result if <id> is not suitable for an IntParam (undefined, or defined for another kind of variable) More...
Standard_Integer | IntValue (const Handle< IFSelect_IntParam > &it) const
| Returns Integer Value of an IntParam. More...
Handle< IFSelect_IntParam > | NewIntParam (const Standard_CString name="")
| Creates a new IntParam. A Name can be set (Optional) Returns the created IntParam, or a Null Handle in case of Failure (see AddItem/AddNamedItem) More...
Standard_Boolean | SetIntValue (const Handle< IFSelect_IntParam > &it, const Standard_Integer val)
| Changes the Integer Value of an IntParam Returns True if Done, False if <it> is not in the WorkSession. More...
Handle< TCollection_HAsciiString > | TextParam (const Standard_Integer id) const
| Returns a TextParam, given its Ident in the Session Null result if <id> is not suitable for a TextParam (undefined, or defined for another kind of variable) More...
TCollection_AsciiString | TextValue (const Handle< TCollection_HAsciiString > &par) const
| Returns Text Value of a TextParam (a String) or an empty string if <it> is not in the WorkSession. More...
Handle< TCollection_HAsciiString > | NewTextParam (const Standard_CString name="")
| Creates a new (empty) TextParam. A Name can be set (Optional) Returns the created TextParam (as an HAsciiString), or a Null Handle in case of Failure (see AddItem/AddNamedItem) More...
Standard_Boolean | SetTextValue (const Handle< TCollection_HAsciiString > &par, const Standard_CString val)
| Changes the Text Value of a TextParam (an HAsciiString) Returns True if Done, False if <it> is not in the WorkSession. More...
Handle< IFSelect_Signature > | Signature (const Standard_Integer id) const
| Returns a Signature, given its Ident in the Session Null result if <id> is not suitable for a Signature (undefined, or defined for another kind of variable) More...
Standard_CString | SignValue (const Handle< IFSelect_Signature > &sign, const Handle< Standard_Transient > &ent) const
| Returns the Value computed by a Signature for an Entity Returns an empty string if the entity does not belong to the loaded model. More...
Handle< IFSelect_Selection > | Selection (const Standard_Integer id) const
| Returns a Selection, given its Ident in the Session Null result if <id> is not suitable for a Selection (undefined, or defined for another kind of variable) More...
Interface_EntityIterator | EvalSelection (const Handle< IFSelect_Selection > &sel) const
| Evaluates the effect of a Selection applied on the input Model Returned Result remains empty if no input Model has been set. More...
IFSelect_SelectionIterator | Sources (const Handle< IFSelect_Selection > &sel) const
| Returns the Selections which are source of Selection, given its rank in the List of Selections (see SelectionIterator) Returned value is empty if <num> is out of range or if <sel> is not in the WorkSession. More...
Handle< TColStd_HSequenceOfTransient > | SelectionResult (const Handle< IFSelect_Selection > &sel) const
| Returns the result of a Selection, computed by EvalSelection (see above) under the form of a HSequence (hence, it can be used by a frontal-engine logic). It can be empty Returns a Null Handle if <sel> is not in the WorkSession. More...
Handle< TColStd_HSequenceOfTransient > | SelectionResultFromList (const Handle< IFSelect_Selection > &sel, const Handle< TColStd_HSequenceOfTransient > &list) const
| Returns the result of a Selection, by forcing its input with a given list unless Null). RULES : only for a SelectDeduct kind Selection : its Input is considered : if it is a SelectDeduct kind Selection, its Input is considered, etc... until an Input is not a Deduct/Extract : its result is replaced by all the chain of deductions is applied. More...
Standard_Boolean | SetItemSelection (const Handle< Standard_Transient > &item, const Handle< IFSelect_Selection > &sel)
| Sets a Selection as input for an item, according its type : if is a Dispatch : as Final Selection if is a GeneralModifier (i.e. any kind of Modifier) : as Selection used to filter entities to modify <sel> Null causes this Selection to be nullified Returns False if is not of a suitable type, or or <sel> is not in the WorkSession. More...
Standard_Boolean | ResetItemSelection (const Handle< Standard_Transient > &item)
| Resets input Selection which was set by SetItemSelection Same conditions as for SetItemSelection Returns True if done, False if is not in the WorkSession. More...
Handle< IFSelect_Selection > | ItemSelection (const Handle< Standard_Transient > &item) const
| Returns the Selection of a Dispatch or a GeneralModifier. Returns a Null Handle if none is defined or not good type. More...
Handle< IFSelect_SignCounter > | SignCounter (const Standard_Integer id) const
| Returns a SignCounter from its ident in the Session Null result if <id> is not suitable for a SignCounter (undefined, or defined for another kind of variable) More...
Standard_Boolean | ComputeCounter (const Handle< IFSelect_SignCounter > &counter, const Standard_Boolean forced=Standard_False)
| Computes the content of a SignCounter when it is defined with a Selection, then returns True Returns False if the SignCounter is not defined with a Selection, or if its Selection Mode is inhibited <forced> to work around optimisations. More...
Standard_Boolean | ComputeCounterFromList (const Handle< IFSelect_SignCounter > &counter, const Handle< TColStd_HSequenceOfTransient > &list, const Standard_Boolean clear=Standard_True)
| Computes the content of a SignCounter from an input list If Null, uses internal definition of the Counter : a Selection, else the whole Model (recomputation forced) If <clear> is True (D), starts from scratch Else, cumulates computations. More...
Handle< TColStd_HSequenceOfInteger > | AppliedDispatches () const
| Returns the ordered list of dispatches stored by the ShareOut. More...
void | ClearShareOut (const Standard_Boolean onlydisp)
| Clears the list of Dispatches recorded by the ShareOut if <only> disp is True, tha's all. Else, clears also the lists of Modifiers recorded by the ShareOut. More...
Handle< IFSelect_Dispatch > | Dispatch (const Standard_Integer id) const
| Returns a Dispatch, given its Ident in the Session Null result if <id> is not suitable for a Dispatch (undefined, or defined for another kind of variable) More...
Standard_Integer | DispatchRank (const Handle< IFSelect_Dispatch > &disp) const
| Returns the rank of a Dispatch in the ShareOut, or 0 if <disp> is not in the ShareOut or not in the WorkSession. More...
Handle< IFSelect_ModelCopier > | ModelCopier () const
| Gives access to the complete ModelCopier. More...
void | SetModelCopier (const Handle< IFSelect_ModelCopier > &copier)
| Sets a new ModelCopier. Fills Items which its content. More...
Standard_Integer | NbFinalModifiers (const Standard_Boolean formodel) const
| Returns the count of Modifiers applied to final sending Model Modifiers if <formodel> is True, File Modifiers else (i.e. Modifiers which apply once the Models have been filled) More...
Handle< TColStd_HSequenceOfInteger > | FinalModifierIdents (const Standard_Boolean formodel) const
| Fills a Sequence with a list of Idents, those attached to the Modifiers applied to final sending. Model Modifiers if <formodel> is True, File Modifiers else This list is given in the order in which they will be applied (which takes into account the Changes to Modifier Ranks) More...
Handle< IFSelect_GeneralModifier > | GeneralModifier (const Standard_Integer id) const
| Returns a Modifier, given its Ident in the Session Null result if <id> is not suitable for a Modifier (undefined, or defined for another kind of variable) More...
Handle< IFSelect_Modifier > | ModelModifier (const Standard_Integer id) const
| Returns a Model Modifier, given its Ident in the Session, i.e. typed as a Modifier (not simply a GeneralModifier) Null result if <id> is not suitable for a Modifier (undefined, or defined for another kind of variable) More...
Standard_Integer | ModifierRank (const Handle< IFSelect_GeneralModifier > &item) const
| Returns the Rank of a Modifier given its Ident. Model or File Modifier according its type (ModelModifier or not) Remember that Modifiers are applied sequencially following their Rank : first Model Modifiers then File Modifiers Rank is given by rank of call to AddItem and can be changed by ChangeModifierRank. More...
Standard_Boolean | ChangeModifierRank (const Standard_Boolean formodel, const Standard_Integer before, const Standard_Integer after)
| Changes the Rank of a Modifier in the Session : Model Modifiers if <formodel> is True, File Modifiers else the Modifier n0 <before> is put to n0 <after> Return True if Done, False if <before> or <after> out of range. More...
void | ClearFinalModifiers ()
| Removes all the Modifiers active in the ModelCopier : they become inactive and they are removed from the Session. More...
Standard_Boolean | SetAppliedModifier (const Handle< IFSelect_GeneralModifier > &modif, const Handle< Standard_Transient > &item)
| Sets a GeneralModifier to be applied to an item : More...
Standard_Boolean | ResetAppliedModifier (const Handle< IFSelect_GeneralModifier > &modif)
| Resets a GeneralModifier to be applied Returns True if done, False if <modif> was not applied. More...
Handle< Standard_Transient > | UsesAppliedModifier (const Handle< IFSelect_GeneralModifier > &modif) const
| Returns the item on which a GeneralModifier is applied : the ShareOut, or a given Dispatch Returns a Null Handle if <modif> is not applied. More...
Handle< IFSelect_Transformer > | Transformer (const Standard_Integer id) const
| Returns a Transformer, given its Ident in the Session Null result if <id> is not suitable for a Transformer (undefined, or defined for another kind of variable) More...
Standard_Integer | RunTransformer (const Handle< IFSelect_Transformer > &transf)
| Runs a Transformer on starting Model, which can then be edited or replaced by a new one. The Protocol can also be changed. Fills LastRunCheckList. More...
Standard_Integer | RunModifier (const Handle< IFSelect_Modifier > &modif, const Standard_Boolean copy)
| Runs a Modifier on Starting Model. It can modify entities, or add new ones. But the Model or the Protocol is unchanged. The Modifier is applied on each entity of the Model. See also RunModifierSelected Fills LastRunCheckList. More...
Standard_Integer | RunModifierSelected (const Handle< IFSelect_Modifier > &modif, const Handle< IFSelect_Selection > &sel, const Standard_Boolean copy)
| Acts as RunModifier, but the Modifier is applied on the list determined by a Selection, rather than on the whole Model If the selection is a null handle, the whole model is taken. More...
Handle< IFSelect_Transformer > | NewTransformStandard (const Standard_Boolean copy, const Standard_CString name="")
| Creates and returns a TransformStandard, empty, with its Copy Option (True = Copy, False = On the Spot) and an optional name. To a TransformStandard, the method SetAppliedModifier applies. More...
Standard_Boolean | SetModelContent (const Handle< IFSelect_Selection > &sel, const Standard_Boolean keep)
| Defines a new content from the former one If <keep> is True, it is given by entities selected by Selection <sel> (and all shared entities) Else, it is given by all the former content but entities selected by the Selection <sel> (and properly shared ones) Returns True if done. Returns False if the selected list (from <sel>) is empty, hence nothing is done. More...
Handle< TCollection_HAsciiString > | FilePrefix () const
| Returns the defined File Prefix. Null Handle if not defined. More...
Handle< TCollection_HAsciiString > | DefaultFileRoot () const
| Returns the defined Default File Root. It is used for Dispatches which have no specific root attached. Null Handle if not defined. More...
Handle< TCollection_HAsciiString > | FileExtension () const
| Returns the defined File Extension. Null Handle if not defined. More...
Handle< TCollection_HAsciiString > | FileRoot (const Handle< IFSelect_Dispatch > &disp) const
| Returns the File Root defined for a Dispatch. Null if no Root Name is defined for it (hence, no File will be produced) More...
void | SetFilePrefix (const Standard_CString name)
| Defines a File Prefix. More...
Standard_Boolean | SetDefaultFileRoot (const Standard_CString name)
| Defines a Default File Root Name. Clears it is <name> = "" Returns True if OK, False if <name> already set for a Dispatch. More...
void | SetFileExtension (const Standard_CString name)
| Defines a File Extension. More...
Standard_Boolean | SetFileRoot (const Handle< IFSelect_Dispatch > &disp, const Standard_CString name)
| Defines a Root for a Dispatch If <name> is empty, clears Root Name This has as effect to inhibit the production of File by <disp> Returns False if <disp> is not in the WorkSession or if a root name is already defined for it. More...
Standard_CString | GiveFileRoot (const Standard_CString file) const
| Extracts File Root Name from a given complete file name (uses OSD_Path) More...
Standard_CString | GiveFileComplete (const Standard_CString file) const
| Completes a file name as required, with Prefix and Extension (if defined; for a non-defined item, completes nothing) More...
void | ClearFile ()
| Erases all stored data from the File Evaluation (i.e. ALL former naming informations are lost) More...
void | EvaluateFile ()
| Performs and stores a File Evaluation. The Results are a List of produced Models and a List of names (Strings), in parallel Fills LastRunCheckList. More...
Standard_Integer | NbFiles () const
| Returns the count of produced Models. More...
Handle< Interface_InterfaceModel > | FileModel (const Standard_Integer num) const
| Returns a Model, given its rank in the Evaluation List. More...
TCollection_AsciiString | FileName (const Standard_Integer num) const
| Returns the name of a file corresponding to a produced Model, given its rank in the Evaluation List. More...
void | BeginSentFiles (const Standard_Boolean record)
| Commands file sending to clear the list of already sent files, commands to record a new one if <record> is True This list is managed by the ModelCopier when SendSplit is called It allows a global exploitation of the set of sent files. More...
Handle< TColStd_HSequenceOfHAsciiString > | SentFiles () const
| Returns the list of recorded sent files, or a Null Handle is recording has not been enabled. More...
Standard_Boolean | SendSplit ()
| Performs creation of derived files from the input Model Takes its data (sub-models and names), from result EvaluateFile if active, else by dynamic Evaluation (not stored) After SendSplit, result of EvaluateFile is Cleared Fills LastRunCheckList. More...
Handle< IFSelect_PacketList > | EvalSplit () const
| Returns an Evaluation of the whole ShareOut definition : i.e. how the entities of the starting model are forecast to be sent to various files : list of packets according the dispatches, effective lists of roots for each packet (which determine the content of the corresponding file); plus evaluation of which entities are : forgotten (sent into no file), duplicated (sent into more than one file), sent into a given file. See the class PacketList for more details. More...
Interface_EntityIterator | SentList (const Standard_Integer count=-1) const
| Returns the list of Entities sent in files, accourding the count of files each one has been sent (these counts are reset by SetModel or SetRemaining(Forget) ) stored in Graph Status <count> = -1 (default) is for ENtities sent at least once <count> = 0 is for the Remaining List (entities not yet sent) <count> = 1 is for entities sent in one and only one file (the ideal case) Remaining Data are computed on each Sending/Copying output files (see methods EvaluateFile and SendSplit) Graph Status is 0 for Remaining Entity, <count> for Sent into <count> files This status is set to 0 (not yet sent) for all by SetModel and by SetRemaining(mode=Forget,Display) More...
Standard_Integer | MaxSendingCount () const
| Returns the greater count of different files in which any of the starting entities could be sent. Before any file output, this count is 0. Ideal count is 1. More than 1 means that duplications occur. More...
Standard_Boolean | SetRemaining (const IFSelect_RemainMode mode)
| Processes Remaining data (after having sent files), mode : Forget : forget remaining info (i.e. clear all "Sent" status) Compute : compute and keep remaining (does nothing if : remaining is empty or if no files has been sent) Display : display entities recorded as remaining Undo : restore former state of data (after Remaining(1) ) Returns True if OK, False else (i.e. mode = 2 and Remaining List is either empty or takes all the entities, or mode = 3 and no former computation of remaining data was done) More...
IFSelect_ReturnStatus | SendAll (const Standard_CString filename, const Standard_Boolean computegraph=Standard_False)
| Sends the starting Model into one file, without splitting, managing remaining data or anything else. <computegraph> true commands the Graph to be recomputed before sending : required when a Model is filled in several steps. More...
IFSelect_ReturnStatus | SendSelected (const Standard_CString filename, const Handle< IFSelect_Selection > &sel, const Standard_Boolean computegraph=Standard_False)
| Sends a part of the starting Model into one file, without splitting. But remaining data are managed. <computegraph> true commands the Graph to be recomputed before sending : required when a Model is filled in several steps. More...
IFSelect_ReturnStatus | WriteFile (const Standard_CString filename)
| Writes the current Interface Model globally to a File, and returns a write status which can be : Done OK, Fail file could not be written, Error no norm is selected Remark : It is a simple, one-file writing, other operations are available (such as splitting ...) which calls SendAll. More...
IFSelect_ReturnStatus | WriteFile (const Standard_CString filename, const Handle< IFSelect_Selection > &sel)
| Writes a sub-part of the current Interface Model to a File, as defined by a Selection <sel>, recomputes the Graph, and returns a write status which can be : Done OK, Fail file could not be written, Error no norm is selected Remark : It is a simple, one-file writing, other operations are available (such as splitting ...) which calls SendSelected. More...
Standard_Integer | NbSources (const Handle< IFSelect_Selection > &sel) const
| Returns the count of Input Selections known for a Selection, or 0 if <sel> not in the WorkSession. This count is one for a SelectDeduct / SelectExtract kind, two for SelectControl kind, variable for a SelectCombine (Union/Intersection), zero else. More...
Handle< IFSelect_Selection > | Source (const Handle< IFSelect_Selection > &sel, const Standard_Integer num=1) const
| Returns the <num>th Input Selection of a Selection (see NbSources). Returns a Null Handle if <sel> is not in the WorkSession or if <num> is out of the range <1-NbSources> To obtain more details, see the method Sources. More...
Standard_Boolean | IsReversedSelectExtract (const Handle< IFSelect_Selection > &sel) const
| Returns True if <sel> a Reversed SelectExtract, False else. More...
Standard_Boolean | ToggleSelectExtract (const Handle< IFSelect_Selection > &sel)
| Toggles the Sense (Direct <-> Reversed) of a SelectExtract Returns True if Done, False if <sel> is not a SelectExtract or is not in the WorkSession. More...
Standard_Boolean | SetInputSelection (const Handle< IFSelect_Selection > &sel, const Handle< IFSelect_Selection > &input)
| Sets an Input Selection (as <input>) to a SelectExtract or a SelectDeduct (as <sel>). Returns True if Done, False if <sel> is neither a SelectExtract nor a SelectDeduct, or not in the WorkSession. More...
Standard_Boolean | SetControl (const Handle< IFSelect_Selection > &sel, const Handle< IFSelect_Selection > &sc, const Standard_Boolean formain=Standard_True)
| Sets an Input Selection, Main if <formain> is True, Second else (as <sc>) to a SelectControl (as <sel>). Returns True if Done, False if <sel> is not a SelectControl, or <sc> or <sel> is not in the WorkSession. More...
Standard_Integer | CombineAdd (const Handle< IFSelect_Selection > &selcomb, const Handle< IFSelect_Selection > &seladd, const Standard_Integer atnum=0)
| Adds an input selection to a SelectCombine (Union or Inters.). Returns new count of inputs for this SelectCombine if Done or 0 if <sel> is not kind of SelectCombine, or if <seladd> or <sel> is not in the WorkSession By default, adding is done at the end of the list Else, it is an insertion to rank <atnum> (usefull for Un-ReDo) More...
Standard_Boolean | CombineRemove (const Handle< IFSelect_Selection > &selcomb, const Handle< IFSelect_Selection > &selrem)
| Removes an input selection from a SelectCombine (Union or Intersection). Returns True if done, False if <selcomb> is not kind of SelectCombine or <selrem> is not source of <selcomb> More...
Handle< IFSelect_Selection > | NewSelectPointed (const Handle< TColStd_HSequenceOfTransient > &list, const Standard_CString name)
| Creates a new Selection, of type SelectPointed, its content starts with A name must be given (can be empty) More...
Standard_Boolean | SetSelectPointed (const Handle< IFSelect_Selection > &sel, const Handle< TColStd_HSequenceOfTransient > &list, const Standard_Integer mode) const
| Changes the content of a Selection of type SelectPointed According <mode> : 0 set new content (clear former) 1 : adds actual content -1 : removes actual content Returns True if done, False if <sel> is not a SelectPointed. More...
Handle< IFSelect_Selection > | GiveSelection (const Standard_CString selname) const
| Returns a Selection from a Name : More...
Handle< TColStd_HSequenceOfTransient > | GiveList (const Handle< Standard_Transient > &obj) const
| Determines a list of entities from an object : <obj> already HSequenceOfTransient : returned itself <obj> Selection : its Result of Evaluation is returned <obj> an entity of the Model : a HSequence which contains it else, an empty HSequence <obj> the Model it self : ALL its content (not only the roots) More...
Handle< TColStd_HSequenceOfTransient > | GiveList (const Standard_CString first, const Standard_CString second="") const
| Computes a List of entities from two alphanums, first and second, as follows : if <first> is a Number or Label of an entity : this entity if <first> is a list of Numbers/Labels : the list of entities if <first> is the name of a Selection in <WS>, and <second> not defined, the standard result of this Selection else, let's consider "first second" : this whole phrase is splitted by blanks, as follows (RECURSIVE CALL) : More...
Handle< TColStd_HSequenceOfTransient > | GiveListFromList (const Standard_CString selname, const Handle< Standard_Transient > &ent) const
| Computes a List of entities from the model as follows <first> beeing a Selection or a combination of Selections, <ent> beeing an entity or a list of entities (as a HSequenceOfTransient) : the standard result of this selection applied to this list if <ent> is Null, the standard definition of the selection is used (which contains a default input selection) if <selname> is erroneous, a null handle is returned. More...
Handle< TColStd_HSequenceOfTransient > | GiveListCombined (const Handle< TColStd_HSequenceOfTransient > &l1, const Handle< TColStd_HSequenceOfTransient > &l2, const Standard_Integer mode) const
| Combines two lists and returns the result, according to mode : <mode> < 0 : entities in <l1> AND NOT in <l2> <mode> = 0 : entities in <l1> AND in <l2> <mode> > 0 : entities in <l1> OR in <l2> More...
void | QueryCheckList (const Interface_CheckIterator &chl)
| Loads data from a check iterator to query status on it. More...
Standard_Integer | QueryCheckStatus (const Handle< Standard_Transient > &ent) const
| Determines check status for an entity regarding last call to QueryCheckList : -1 : <ent> unknown in the model, ignored 0 : no check at all, immediate or inherited thru Graph 1 : immediate warning (no fail), no inherited check 2 : immediate fail, no inherited check +10 : idem but some inherited warning (no fail) +20 : idem but some inherited fail. More...
Standard_Integer | QueryParent (const Handle< Standard_Transient > &entdad, const Handle< Standard_Transient > &entson) const
| Determines if <entdad> is parent of <entson> (in the graph), returns : -1 if no; 0 if <entdad> = <entson> 1 if immediate parent, > 1 if parent, gives count of steps. More...
void | SetParams (const TColStd_SequenceOfTransient &params, const TColStd_SequenceOfInteger &uselist)
| Sets a list of Parameters, i.e. TypedValue, to be handled through an Editor The two lists are parallel, if <params> is longer than <uses>, surnumeral parameters are for general use. More...
void | TraceStatics (const Standard_Integer use, const Standard_Integer mode=0) const
| Traces the Statics attached to a given use number If <use> is given positive (normal), the trace is embedded with a header and a trailer If <use> is negative, just values are printed (this allows to make compositions) Remark : use number 5 commands use -2 to be traced Remark : use numbers 4 and 6 command use -3 to be traced. More...
void | DumpShare () const
| Dumps contents of the ShareOut (on "cout") More...
void | ListItems (const Standard_CString label="") const
| Lists the Labels of all Items of the WorkSession If <label> is defined, lists labels which contain it. More...
void | ListFinalModifiers (const Standard_Boolean formodel) const
| Lists the Modifiers of the session (for each one, displays its Label). Listing is done following Ranks (Modifiers are invoked following their ranks) Model Modifiers if <formodel> is True, File Modifiers else. More...
void | DumpSelection (const Handle< IFSelect_Selection > &sel) const
| Lists a Selection and its Sources (see SelectionIterator), given its rank in the list. More...
void | DumpModel (const Standard_Integer level, const Handle< Message_Messenger > &S)
| Lists the content of the Input Model (if there is one) According level : 0 -> gives only count of Entities and Roots 1 -> Lists also Roots; 2 -> Lists all Entities (by TraceType) 3 -> Performs a call to CheckList (Fails) and lists the result 4 -> as 3 but all CheckList (Fails + Warnings) 5,6,7 : as 3 but resp. Count,List,Labels by Fail 8,9,10 : as 4 but resp. Count,List,Labels by message. More...
void | TraceDumpModel (const Standard_Integer mode)
| Dumps the current Model (as inherited DumpModel), on currently defined Default Trace File (default is standard output) More...
void | DumpEntity (const Handle< Standard_Transient > &ent, const Standard_Integer level, const Handle< Message_Messenger > &S) const
| Dumps a starting entity according to the current norm. To do this, it calls DumpEntity from WorkLibrary. <level> is to be interpreted for each norm : see specific classes of WorkLibrary for it. Generally, 0 if for very basic (only type ...), greater values give more and more details. More...
void | PrintEntityStatus (const Handle< Standard_Transient > &ent, const Handle< Message_Messenger > &S)
| Prints main informations about an entity : its number, type, validity (and checks if any), category, shareds and sharings.. mutable because it can recompute checks as necessary. More...
void | TraceDumpEntity (const Handle< Standard_Transient > &ent, const Standard_Integer level) const
| Dumps an entity from the current Model as inherited DumpEntity on currently defined Default Trace File (<level> interpreted according to the Norm, see WorkLibrary) More...
void | PrintCheckList (const Interface_CheckIterator &checklist, const Standard_Boolean failsonly, const IFSelect_PrintCount mode) const
| Prints a CheckIterator to the current Trace File, controlled with the current Model complete or fails only, according to <failsonly> <mode> defines the mode of printing 0 : sequential, according entities; else with a CheckCounter 1 : according messages, count of entities 2 : id but with list of entities, designated by their numbers 3 : as 2 but with labels of entities. More...
void | PrintSignatureList (const Handle< IFSelect_SignatureList > &signlist, const IFSelect_PrintCount mode) const
| Prints a SignatureList to the current Trace File, controlled with the current Model <mode> defines the mode of printing (see SignatureList) More...
void | EvaluateSelection (const Handle< IFSelect_Selection > &sel) const
| Displays the list of Entities selected by a Selection (i.e. the result of EvalSelection). More...
void | EvaluateDispatch (const Handle< IFSelect_Dispatch > &disp, const Standard_Integer mode=0) const
| Displays the result of applying a Dispatch on the input Model (also shows Remainder if there is) <mode> = 0 (default), displays nothing else <mode> = 1 : displays also duplicated entities (because of this dispatch) <mode> = 2 : displays the entities of the starting Model which are not taken by this dispatch (forgotten entities) <mode> = 3 : displays both duplicated and forgotten entities Remark : EvaluateComplete displays these data evaluated for for all the dispatches, if there are several. More...
void | EvaluateComplete (const Standard_Integer mode=0) const
| Displays the effect of applying the ShareOut on the input Model. <mode> = 0 (default) : displays only roots for each packet, <mode> = 1 : displays all entities for each packet, plus duplicated entities <mode> = 2 : same as <mode> = 1, plus displays forgotten entities (which are in no packet at all) More...
void | ListEntities (const Interface_EntityIterator &iter, const Standard_Integer mode) const
| Internal method which displays an EntityIterator <mode> 0 gives short display (only entity numbers) 1 gives a more complete trace (1 line per Entity) (can be used each time a trace has to be output from a list) 2 gives a form suitable for givelist : (n1,n2,n3...) More...
Public Member Functions inherited from MMgt_TShared
virtual void | Delete () const
| Memory deallocator for transient classes. More...
Public Member Functions inherited from Standard_Transient
| Standard_Transient ()
| Empty constructor. More...
| Standard_Transient (const Standard_Transient &)
| Copy constructor – does nothing. More...
Standard_Transient & | operator= (const Standard_Transient &)
| Assignment operator, needed to avoid copying reference counter. More...
virtual | ~Standard_Transient ()
| Destructor must be virtual. More...
virtual const Handle_Standard_Type & | DynamicType () const
| Returns a type information object about this object. More...
Standard_Boolean | IsInstance (const Handle_Standard_Type &theType) const
| Returns a true value if this is an instance of Type. More...
Standard_Boolean | IsInstance (const Standard_CString theTypeName) const
| Returns a true value if this is an instance of TypeName. More...
Standard_Boolean | IsKind (const Handle_Standard_Type &theType) const
| Returns true if this is an instance of Type or an instance of any class that inherits from Type. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
Standard_Boolean | IsKind (const Standard_CString theTypeName) const
| Returns true if this is an instance of TypeName or an instance of any class that inherits from TypeName. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
virtual Handle_Standard_Transient | This () const
| Returns a Handle which references this object. Must never be called to objects created in stack. More...
Standard_Integer | GetRefCount () const
| Get the reference counter of this object. More...

## Additional Inherited Members
Protected Attributes inherited from IFSelect_WorkSession
Handle< Interface_HGraph > | thegraph
Interface_CheckIterator | thecheckrun
TColStd_IndexedDataMapOfTransientTransient | theitems
Handle< Dico_DictionaryOfTransient > | thenames

## Detailed Description

This WorkSession completes the basic one, by adding :

- use of Controller, with norm selection...
- management of transfers (both ways) with auxiliary classes TransferReader and TransferWriter -> these transfers may work with a Context List : its items are given by the user, according to the transfer to be i.e. it is interpreted by the Actors Each item is accessed by a Name

## Constructor & Destructor Documentation

XSControl_WorkSession::XSControl_WorkSession | ( |  | ) |

XSControl_WorkSession::~XSControl_WorkSession | ( |  | ) |
| inline

## Member Function Documentation

virtual void XSControl_WorkSession::AdaptNorm | ( |  | ) |
| virtual

This method is called once a new norm has been successfully selected. It can be redefined, default does nothing.

void XSControl_WorkSession::ClearBinders | ( |  | ) |

Clears binders.

void XSControl_WorkSession::ClearContext | ( |  | ) |

Clears the whole current Context (nullifies it)

virtual void XSControl_WorkSession::ClearData | ( | const Standard_Integer | mode | ) |
| virtual

In addition to basic ClearData, clears Transfer and Management for interactive use, for mode = 0,1,2 and over 4 Plus : mode = 5 to clear Transfers (both ways) only mode = 6 to clear enforced results mode = 7 to clear transfers, results.

Reimplemented from IFSelect_WorkSession.

Handle< Dico_DictionaryOfTransient > XSControl_WorkSession::Context | ( |  | ) | const

Returns the current Context List, Null if not defined The Context is given to the TransientProcess for TransferRead.

void XSControl_WorkSession::Destroy | ( |  | ) |

void XSControl_WorkSession::InitTransferReader | ( | const Standard_Integer | mode | ) |

Sets a Transfer Reader, by internal ways, according mode : 0 recreates it clear, 1 clears it (does not recreate) 2 aligns Roots of TransientProcess from final Results 3 aligns final Results from Roots of TransientProcess 4 begins a new transfer (by BeginTransfer) 5 recreates TransferReader then begins a new transfer.

Handle< Transfer_TransientProcess > XSControl_WorkSession::MapReader | ( |  | ) | const

Returns the TransientProcess(internal data for TransferReader)

Handle< Transfer_FinderProcess > XSControl_WorkSession::MapWriter | ( |  | ) | const

Returns the FinderProcess (internal data for TransferWriter)

Standard_Integer XSControl_WorkSession::ModeWriteShape | ( |  | ) | const

Records the current Mode to Write Shapes.

Handle< Interface_InterfaceModel > XSControl_WorkSession::NewModel | ( |  | ) |

produces and returns a new Model well conditionned It is produced by the Norm Controller It can be Null (if this function is not implemented)

Handle< XSControl_Controller > XSControl_WorkSession::NormAdaptor | ( |  | ) | const

Returns the norm controller itself.

Standard_Boolean XSControl_WorkSession::PrintTransferStatus | ( | const Standard_Integer | num,
|  | const Standard_Boolean | wri,
|  | const Handle< Message_Messenger > & | S
| ) |  | const

Prints the transfer status of a transferred item, as beeing the Mapped n0 <num>, from MapWriter if <wri> is True, or from MapReader if <wri> is False Returns True when done, False else (i.e. num out of range)

Handle< Standard_Transient > XSControl_WorkSession::Result | ( | const Handle< Standard_Transient > & | ent,
|  | const Standard_Integer | mode
| ) |  | const

Returns the result attached to a starting entity If <mode> = 0, returns Final Result If <mode> = 1, considers Last Result If <mode> = 2, considers Final, else if absent, Last returns it as Transient, if result is not transient returns the Binder <mode> = 10,11,12 idem but returns the Binder itself (if it is not, e.g. Shape, returns the Binder) <mode> = 20, returns the ResultFromModel.

Standard_CString XSControl_WorkSession::SelectedNorm | ( | const Standard_Boolean | rsc = `Standard_False` | ) | const

Returns the name of the last Selected Norm. If none is defined, returns an empty string By default, returns the complete name of the norm If <rsc> is True, returns the short name used for resource.

Standard_Boolean XSControl_WorkSession::SelectNorm | ( | const Standard_CString | normname,
|  | const Standard_CString | profile = `""`
| ) |  |

Selects a Norm defined by its name. A Norm is described and handled by a Controller Returns True if done, False if <normname> is unknown.

A Profile may be set too. If no Profile is provided, the current Profile for this Norm is taken If the asked Profile is not defined for this Norm, it remains in current Profile, returned value is True

Standard_Boolean XSControl_WorkSession::SelectProfile | ( | const Standard_CString | profile | ) |

Sets a Profile as current for the current Norm Returns True if done, False if <profile> is unknown for this norm.

For more infos on Profile, query the Profile of the Controller

void XSControl_WorkSession::SetAllContext | ( | const Handle< Dico_DictionaryOfTransient > & | context | ) |

Sets the current Context List, as a whole Sets it to the TransferReader.

void XSControl_WorkSession::SetController | ( | const Handle< XSControl_Controller > & | ctl | ) |

Selects a Norm defined by its Controller itself.

Standard_Boolean XSControl_WorkSession::SetMapReader | ( | const Handle< Transfer_TransientProcess > & | TP | ) |

Changes the Map Reader, i.e. considers that the new one defines the relevant read results (forgets the former ones) Returns True when done, False in case of bad definition, i.e. if Model from TP differs from that of Session.

Standard_Boolean XSControl_WorkSession::SetMapWriter | ( | const Handle< Transfer_FinderProcess > & | FP | ) |

Changes the Map Reader, i.e. considers that the new one defines the relevant read results (forgets the former ones) Returns True when done, False if <FP> is Null.

void XSControl_WorkSession::SetModeWriteShape | ( | const Standard_Integer | mode | ) |

Sets a mode to transfer Shapes from CasCade to entities of the current norm, which interprets it (see various Controllers) This call form could be later replaced by a more general one.

void XSControl_WorkSession::SetTransferReader | ( | const Handle< XSControl_TransferReader > & | TR | ) |

Sets a Transfer Reader, which manages transfers on reading.

void XSControl_WorkSession::SetVars | ( | const Handle< XSControl_Vars > & | newvars | ) |

Handle< XSControl_TransferReader > XSControl_WorkSession::TransferReader | ( |  | ) | const

Returns the Transfer Reader, Null if not set.

Standard_Integer XSControl_WorkSession::TransferReadOne | ( | const Handle< Standard_Transient > & | ents | ) |

Commands the transfer of, either one entity, or a list I.E. calls the TransferReader after having analysed <ents> It is cumulated from the last BeginTransfer <ents> is processed by GiveList, hence :

- <ents> a Selection : its SelectionResult
- <ents> a HSequenceOfTransient : this list
- <ents> the Model : in this specific case, all the roots, with no cumulation of former transfers (TransferReadRoots)

Standard_Integer XSControl_WorkSession::TransferReadRoots | ( |  | ) |

Commands the transfer of all the root entities of the model i.e. calls TransferRoot from the TransferReader with the Graph No cumulation with former calls to TransferReadOne.

Interface_CheckIterator XSControl_WorkSession::TransferWriteCheckList | ( |  | ) | const

Returns the check-list of last transfer (write) It is recorded in the FinderProcess, but it must be bound with resulting entities (in the resulting file model) rather than with original objects (in fact, their mappers)

Handle< XSControl_TransferWriter > XSControl_WorkSession::TransferWriter | ( |  | ) | const

Returns the Transfer Reader, Null if not set.

IFSelect_ReturnStatus XSControl_WorkSession::TransferWriteShape | ( | const TopoDS_Shape & | shape,
|  | const Standard_Boolean | compgraph = `Standard_True`
| ) |  |

Transfers a Shape from CasCade to a model of current norm, according to the last call to SetModeWriteShape Returns status :Done if OK, Fail if error during transfer, Error if transfer badly initialised.

Handle< XSControl_Vars > XSControl_WorkSession::Vars | ( |  | ) | const

The documentation for this class was generated from the following file:

- XSControl_WorkSession.hxx